// This file is generated by kconfig_compiler from killbots.kcfg.
// All changes you do to this file will be lost.
#ifndef KILLBOTS_SETTINGS_H
#define KILLBOTS_SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

namespace Killbots {

class Settings : public KConfigSkeleton
{
  public:
    enum ClickAction { Nothing, Step, RepeatedStep, Teleport, TeleportSafely, TeleportSafelyIfPossible, WaitOutRound };

    static Settings *self();
    ~Settings();

    /**
      Set MiddleClickAction
    */
    static
    void setMiddleClickAction( ClickAction v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "MiddleClickAction" ) ))
        self()->mMiddleClickAction = v;
    }

    /**
      Get MiddleClickAction
    */
    static
    ClickAction middleClickAction()
    {
      return static_cast<ClickAction>(self()->mMiddleClickAction);
    }

    /**
      Get Item object corresponding to MiddleClickAction()
    */
    ItemEnum *middleClickActionItem()
    {
      return mMiddleClickActionItem;
    }

    /**
      Set RightClickAction
    */
    static
    void setRightClickAction( ClickAction v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "RightClickAction" ) ))
        self()->mRightClickAction = v;
    }

    /**
      Get RightClickAction
    */
    static
    ClickAction rightClickAction()
    {
      return static_cast<ClickAction>(self()->mRightClickAction);
    }

    /**
      Get Item object corresponding to RightClickAction()
    */
    ItemEnum *rightClickActionItem()
    {
      return mRightClickActionItem;
    }

    /**
      Set AnimationSpeed
    */
    static
    void setAnimationSpeed( int v )
    {
      if (v < 0)
      {
        kDebug() << "setAnimationSpeed: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > 10)
      {
        kDebug() << "setAnimationSpeed: value " << v << " is greater than the maximum value of 10" << endl;
        v = 10;
      }

      if (!self()->isImmutable( QString::fromLatin1 ( "AnimationSpeed" ) ))
        self()->mAnimationSpeed = v;
    }

    /**
      Get AnimationSpeed
    */
    static
    int animationSpeed()
    {
      return self()->mAnimationSpeed;
    }

    /**
      Get Item object corresponding to AnimationSpeed()
    */
    ItemInt *animationSpeedItem()
    {
      return mAnimationSpeedItem;
    }

    /**
      Set PreventUnsafeMoves
    */
    static
    void setPreventUnsafeMoves( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "PreventUnsafeMoves" ) ))
        self()->mPreventUnsafeMoves = v;
    }

    /**
      Get PreventUnsafeMoves
    */
    static
    bool preventUnsafeMoves()
    {
      return self()->mPreventUnsafeMoves;
    }

    /**
      Get Item object corresponding to PreventUnsafeMoves()
    */
    ItemBool *preventUnsafeMovesItem()
    {
      return mPreventUnsafeMovesItem;
    }

    /**
      Set Ruleset
    */
    static
    void setRuleset( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Ruleset" ) ))
        self()->mRuleset = v;
    }

    /**
      Get Ruleset
    */
    static
    QString ruleset()
    {
      return self()->mRuleset;
    }

    /**
      Get Item object corresponding to Ruleset()
    */
    ItemString *rulesetItem()
    {
      return mRulesetItem;
    }

    /**
      Set Theme
    */
    static
    void setTheme( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Theme" ) ))
        self()->mTheme = v;
    }

    /**
      Get Theme
    */
    static
    QString theme()
    {
      return self()->mTheme;
    }

    /**
      Get Item object corresponding to Theme()
    */
    ItemString *themeItem()
    {
      return mThemeItem;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // General
    int mMiddleClickAction;
    int mRightClickAction;
    int mAnimationSpeed;
    bool mPreventUnsafeMoves;
    QString mRuleset;
    QString mTheme;

  private:
    ItemEnum *mMiddleClickActionItem;
    ItemEnum *mRightClickActionItem;
    ItemInt *mAnimationSpeedItem;
    ItemBool *mPreventUnsafeMovesItem;
    ItemString *mRulesetItem;
    ItemString *mThemeItem;
};

}

#endif

